<!DOCTYPE html>
<html>
  <head>
    <script src="https://cdn.rawgit.com/konvajs/konva/2.0.3/konva.min.js"></script>
    <meta charset="utf-8">
    <title>Tear Walls</title>
    <style>
      body {
        margin: 0;
        padding: 0;
        overflow: hidden;
        background-color: #F0F0F0;
      }
    </style>
  </head>
  <body>
    <div id="container"></div>
    <script>

      var viewport_width = window.innerWidth
      var viewport_height = window.innerHeight

      var playground_width;
      var playground_height;
      var playground_half_height;
      var playground_height_width_ratio = 2; // if height=200 then width=400, i.e. height-width-ratio=2
      var playground_x;
      var playground_y;
      var playground_margin = 10;
      var paddle_width;
      var paddle_height;
      var paddle_half_width;
      var paddle_width_height_ratio = 4; // if width=10 then height=40, i.e. width-height-ratio=4
      var paddle_x;
      var paddle_y;

      if ((viewport_width / viewport_height) > playground_height_width_ratio) {
        playground_half_height = Math.floor((viewport_height - (2 * playground_margin)) / 2);
      } else {
        playground_half_height = Math.floor((viewport_width - (2 * playground_margin)) / 4);
      }

      playground_height = 2 * playground_half_height;
      playground_width = playground_height * playground_height_width_ratio;
      playground_x = Math.floor((viewport_width - playground_width) / 2);
      playground_y = playground_margin;

      paddle_half_width = Math.floor(playground_half_height / 24);
      paddle_width = 2 * paddle_half_width;
      paddle_height = paddle_width * paddle_width_height_ratio;

      var stage = new Konva.Stage({
        container: 'container',
        width: viewport_width,
        height: viewport_height
      });

      var background_layer = new Konva.Layer();

        var background_image = new Image();
        background_image.onload = function() {
          var bgimage = new Konva.Image({
            x: 100,
            y: 100,
            image: background_image,
            width: 120,
            height: 120
          });
          background_layer.add(bgimage);
        };
        background_image.src = 'assets/background.png'

      var playground = new Konva.Rect({
        x: playground_x,
        y: playground_y,
        width: playground_width,
        height: playground_height,
        fill: 'gray',
        stroke: 'blue',
        strokeWidth: 1
      });

      var foreground_layer = new Konva.Layer();

      // var text = new Konva.Text({
      //   x: playground_x + 10,
      //   y: 10,
      //   fontFamily: 'Calibri',
      //   fontSize: 24,
      //   text: '',
      //   fill: 'red'
      // });

      paddle_x = playground_x;
      paddle_y = playground_half_height - (paddle_half_width * paddle_width_height_ratio) + playground_y;

      var paddle = new Konva.Rect({
        x: paddle_x,
        y: paddle_y,
        width: paddle_width,
        height: paddle_height,
        fill: 'yellow',
        stroke: 'blue',
        strokeWidth: 1
      });

      playground.on('mousemove', function () {
        pointerMove();
      });

      playground.on('touchmove', function () {
        pointerMove();
      });

      paddle.on('mousemove', function () {
        pointerMove();
      });

      function pointerMove() {
        var position = stage.getPointerPosition();
        var x = Math.floor(position.x) - playground_x;
        var y = Math.floor(position.y) - playground_y;

        // text.setText('x: ' + x + ', y: ' + y);

        new_paddle_position = y + playground_margin - paddle_half_width * paddle_width_height_ratio;
        if (new_paddle_position < playground_y) {
          new_paddle_position = playground_y;
        }
        if((new_paddle_position + paddle_height) > (playground_y + playground_height)) {
          new_paddle_position = playground_y + playground_height - paddle_height
        }
        paddle.y(new_paddle_position);

        foreground_layer.draw();
      }

      background_layer.add(playground);
      // foreground_layer.add(text);
      foreground_layer.add(paddle);
      stage.add(background_layer, foreground_layer);

    </script>
  </body>
</html>
